// ݱ(hemisphere lighting)
// base : EffectEdit


string XFile = "SkullOcc.x";                // ޽
int    BCLR  = 0xff202080;                  // 

//   (view space)
float3 DirFromLight < string UIDirectional = "Light Direction"; > = {0.577, -0.577, 0.577};

// õݱ   (view space)
float3 DirFromSky < string UIDirectional = "Direction from Sky"; > = { 0.0f, -1.0f, 0.0f };            

//  
float4 I_a = { 0.5f, 0.5f, 0.5f, 1.0f };    // ֺ   
float4 I_b = { 1.0f, 1.0f, 0.0f, 1.0f };    // ݱ 
float4 I_c = { 1.0f, 0.0f, 0.0f, 1.0f };    // õݱ 
float4 I_d = { 1.0f, 0.9f, 0.8f, 1.0f };    // Ȯ   
float4 I_s = { 1.0f, 1.0f, 1.0f, 1.0f };    // ݻ   

// 
float4 k_a = { 0.8f, 0.8f, 0.8f, 1.0f };    // ֺ 
float4 k_d = { 0.4f, 0.4f, 0.4f, 1.0f };    // Ȯ걤 
float4 k_s = { 0.1f, 0.1f, 0.1f, 1.0f };    // ݻ籤 
int    n   = 32;                            // 


// ȯ
float4x3 WorldView  : WORLDVIEW;
float4x4 Projection : PROJECTION;

// 
struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float4 Diff : COLOR0;
    float4 Spec : COLOR1;
};

// ̴
VS_OUTPUT VS(
    float3 Pos  : POSITION, 
    float3 Norm : NORMAL, 
    float  Occ  : TEXCOORD0,
    uniform bool bHemi, 		// ݱ?
    uniform bool bDiff,			// Ȯ?
    uniform bool bSpec)			// ݻ?
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    float3 L = -DirFromLight;                               // Ȯ걤 ⺤
    float3 Y = -DirFromSky;                                 // õݱ 
    float3 P = mul(float4(Pos, 1), (float4x3)WorldView);    //  ġ (view space)
    float3 N = normalize(mul(Norm, (float3x3)WorldView));   //   (view space)
    float3 R = normalize(2 * dot(N, L) * N - L);            // ݻ  (view space)
    float3 V = -normalize(P);                               //   (view space)

    float4 Amb  = k_a * I_a;								// ֺ 
	// ݱ  : color = (0.5+cos())*Sky + (0.5-cos())*Ground
//	float4 Hemi = k_a * ((0.5+dot(N,Y))*I_c + (0.5-dot(N,Y))*I_b) * (1 - Occ);
	
	// ݱ ٸ : color = a*Sky + (1-a)*Ground
	//  a = (1+cos())/2 = (1+dot(N,A))/2, (0 <= a <= 1)
	float4 Hemi = k_a * lerp(I_b, I_c, (dot(N, Y) + 1) / 2) * (1 - Occ);	// ݱ
    float  temp = 1 - max(0, dot(N, L));					// 
    float4 Diff = k_d * I_d * (1 - temp * temp);			// Ȯ 
    float4 Spec = k_s * I_s * pow(max(0, dot(R, V)), n/4);	// ݻ 
    float4 Zero = 0;

    Out.Pos  = mul(float4(P, 1), Projection);               //  ġ (projected)
    Out.Diff = (bDiff ? Diff : 0)							// Ȯ ? Ȯ : 0
             + (bHemi ? Hemi : Amb);                        // diffuse + ݱ ? ֺ : ݱ
    Out.Spec = (bSpec ? Spec : 0);                          // ݻ ? ݻ : 0

    return Out;
}

// ݱ 
technique THemisphere
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS(true, false, false);
    }
}

// ݱ + Ȯ
technique THemisphereDiffuse
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS(true, true, false);
    }
}

// ݱ + Ȯ + ݻ
technique THemisphereDiffuseSpecular
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS(true, true, true);

        SpecularEnable = TRUE;
    }
}

// ֺ
technique TAmbient
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS(false, false, false);
    }
}

// ֺ + Ȯ
technique TAmbientDiffuse
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS(false, true, false);
    }
}

// ֺ + Ȯ + ݻ
technique TAmbientDiffuseSpecular
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS(false, true, true);

        SpecularEnable = TRUE;
    }
}

