// 
// base : EffectEdit

string XFile = "teapot.x";   // ޽
string BIMG  = "lobbyzpos.JPG"; 
int    BCLR = 0xff202080;   // 

//   (view space)
float3 lightDir <  string UIDirectional = "Light Direction"; > = {0.577, -0.577, 0.577};

// ȯؽó
texture TexEnv
< 
    string type = "CUBE"; 
    string name = "lobbycube.dds"; 
>;

// ⺻ؽó
texture TexDiff < string name = "tiger.bmp"; >;

// ȯ
float4x4 World      : WORLD;
float4x4 View       : VIEW;
float4x4 Projection : PROJECTION;

//,  100%
float etaRatio = 0.01;
float transmittance = 1.0;

struct VS_OUT
{
	float4 Pos    : POSITION;
	float2 Tex    : TEXCOORD0;
	float3 R      : TEXCOORD1; // ݻ纤
};

VS_OUT VS(
	float3 inPos  : POSITION,
	float3 inNorm : NORMAL,
	float2 inTex  : TEXCOORD0 )
{
	VS_OUT	o;
	
	// ġ
	float4x4 WV = mul( World, View );
	float3 P = mul(float4(inPos, 1), (float4x3)WV);
	o.Pos = mul(float4(P, 1), Projection);
	
	// ؽó
	o.Tex = inTex;

	// ǥ迡  ġ
	P = mul( float4(inPos,1), World ).xyz;
	// ǥ迡  
	float3 N = mul( inNorm, (float3x3)World );
	N = normalize( N );

	float3 VP = -float3( View._41, View._42, View._43 );
	float3x3 VI = transpose( (float3x3)(View) );
	float3 V = mul( VP, VI );

	// ( - ī޶) Ի纤(entering vector) Ѵ
	float3 I = V - P;
	
	//   Ի纤 ͸ Ѵ.
	o.R = 0.5 * dot(I, N) * N-I;
	return o;
}

// ؽó ÷
sampler SamplerDiff = sampler_state
{
    Texture   = (TexDiff);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

sampler SamplerEnv = sampler_state
{
    Texture   = (TexEnv);
    MipFilter = LINEAR;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

// ȼ̴
float4 PS( float2 Tex : TEXCOORD0,
           float3 R   : TEXCOORD1 ) : COLOR
{
	// ݻ纤͸  Թüʿ ؽó о´
	float4 refractedColor = texCUBE( SamplerEnv, R);
	// ⺻ ؽó д´
	float4 diffuseColor = tex2D( SamplerDiff, Tex );
	// ⺻ؽó ݻؽó   Ѵ
	float4 color = lerp( diffuseColor, refractedColor, transmittance);
	
	//    
    return color;
}

// ũ (̴ & ȼ ̴ )
technique TVertexAndPixelShader
{
    pass P0
    {
        // shaders
        VertexShader = compile vs_2_0 VS();
        PixelShader  = compile ps_2_0 PS();
    }  
}